## xmlrpc-c 1.59.03

=== examples/Makefile ===
# Since the programs in this directory are examples for the user, this make
# file should be as ordinary as possible.  It should not rely heavily on
# included make files or configuration parameters.  Also, we don't try to
# build or rebuild the libraries on which these programs depend or even
# recognize that they've changed on their own.


ifeq ($(SRCDIR),)
SRCDIR = $(CURDIR)/..
BLDDIR = $(SRCDIR)
endif
SUBDIR = examples

include $(BLDDIR)/config.mk

default: all

CFLAGS_ALL = $(CFLAGS_PERSONAL) $(CFLAGS) $(CADD)
LDFLAGS_ALL = $(LDFLAGS_PERSONAL) $(LDFLAGS) $(LADD)

# If this were a real application, working from an installed copy of
# Xmlrpc-c, XMLRPC_C_CONFIG would just be 'xmlrpc-c-config'.  It would be
# found in the user's PATH.
XMLRPC_C_CONFIG = $(BLDDIR)/xmlrpc-c-config.test

CLIENTPROGS = \
  auth_client \
  compound_value_client \
  synch_client \
  xmlrpc_sample_add_client \
  xmlrpc_asynch_client \

ifeq ($(MUST_BUILD_CURL_CLIENT),yes)
  ifneq ($(MSVCRT),yes)
    CLIENTPROGS += curl_client
    CLIENTPROGS += interrupted_client
  endif
endif

SERVERPROGS_CGI = \
  xmlrpc_sample_add_server.cgi

SERVERPROGS_ABYSS = \
  compound_value_server \
  xmlrpc_inetd_server \
  xmlrpc_socket_server \
  xmlrpc_loop_server \
  xmlrpc_sample_add_server \
  xmlrpc_server_validatee \

ifneq ($(MSVCRT),yes)
  SERVERPROGS_ABYSS += interrupted_server
endif

ifeq ($(MUST_BUILD_ABYSS_OPENSSL),yes)
  SERVERPROGS_ABYSS += ssl_server ssl_secure_server
endif

BASIC_PROGS = \
  json \
  gen_sample_add_xml \

# Build up PROGS:
PROGS = 

PROGS += $(BASIC_PROGS)

ifeq ($(ENABLE_ABYSS_SERVER),yes)
  PROGS += $(SERVERPROGS_ABYSS)
endif

ifeq ($(MUST_BUILD_CLIENT),yes)
  PROGS += $(CLIENTPROGS)
endif

ifeq ($(ENABLE_CGI_SERVER),yes)
  PROGS += $(SERVERPROGS_CGI) 
endif

INCLUDES = -I. $(shell $(XMLRPC_C_CONFIG) client abyss-server --cflags)

LIBS_CLIENT = \
  $(shell $(XMLRPC_C_CONFIG) client --libs)

LIBS_SERVER_ABYSS = \
  $(shell $(XMLRPC_C_CONFIG) abyss-server --libs)

LIBS_SERVER_CGI = \
  $(shell $(XMLRPC_C_CONFIG) cgi-server --libs)

LIBS_BASE = \
  $(shell $(XMLRPC_C_CONFIG) --libs)

all: $(PROGS)

ifeq ($(ENABLE_CPLUSPLUS),yes)
  all: cpp/all
endif

.PHONY: cpp/all
cpp/all: $(BLDDIR)/examples/cpp
	$(MAKE) -C cpp -f $(SRCDIR)/examples/cpp/Makefile all

# When building in separate tree, directory won't exist yet
$(BLDDIR)/examples/cpp:
	mkdir $@

$(CLIENTPROGS):%:%.o
	$(CCLD) -o $@ $^ $(LIBS_CLIENT) $(LDFLAGS_ALL)

$(SERVERPROGS_CGI):%.cgi:%_cgi.o
	$(CCLD) -o $@ $^ $(LIBS_SERVER_CGI) $(LDFLAGS_ALL)

$(SERVERPROGS_ABYSS):%:%.o
	$(CCLD) -o $@ $^ $(LIBS_SERVER_ABYSS) $(LDFLAGS_ALL)

$(BASIC_PROGS):%:%.o
	$(CCLD) -o $@ $^ $(LIBS_BASE) $(LDFLAGS_ALL)


OBJECTS = $(patsubst %,%.o,$(patsubst %.cgi,%_cgi,$(PROGS)))

$(OBJECTS):%.o:%.c
	$(CC) -c $(INCLUDES) $(CFLAGS_ALL) $<

# config.h just describes the build environment.  We use it so that the
# example programs will build in users' various environments.  If you're
# copying these examples, you can just remove this header from the programs
# and hardcode whatever is right for your build environment.

$(OBJECTS): config.h

config.h:
	$(LN_S) $(BLDDIR)/xmlrpc_config.h $@

.PHONY: clean
clean:
	rm -f $(PROGS) *.o config.h
	$(MAKE) -C cpp clean

.PHONY: distclean
distclean: clean

.PHONY: install
install:

.PHONY: uninstall
uninstall:

.PHONY: check
check:

.PHONY: dep depend
dep depend:
# We don't do dependencies in this directory, because it's supposed to be
# an example of what a program outside this package would do, so we can't
# go weaving it into the rest of the package.  Ergo, a developer must
# carefully clean and remake examples as he updates other parts of the tree.

=== lib/Makefile ===
ifeq ($(SRCDIR),)
  updir = $(shell echo $(dir $(1)) | sed 's/.$$//')
  SRCDIR := $(call updir,$(CURDIR))
  BLDDIR := $(SRCDIR)
endif
SUBDIR := lib

include $(BLDDIR)/config.mk

# Build up SUBDIRS:
SUBDIRS = 
SUBDIRS += util libutil
ifeq ($(ENABLE_CPLUSPLUS),yes)
  SUBDIRS += libutil++
endif
ifeq ($(ENABLE_ABYSS_SERVER),yes)
  SUBDIRS += abyss
  ifeq ($(ENABLE_CPLUSPLUS),yes)
    SUBDIRS += abyss++
  endif
endif
ifeq ($(MUST_BUILD_WININET_CLIENT),yes)
  SUBDIRS += wininet_transport
endif
ifeq ($(MUST_BUILD_CURL_CLIENT),yes)
  SUBDIRS += curl_transport
endif
ifeq ($(MUST_BUILD_LIBWWW_CLIENT),yes)
  SUBDIRS += libwww_transport
endif
ifneq ($(ENABLE_LIBXML2_BACKEND),yes)
  SUBDIRS += expat
endif

ifeq ($(HAVE_OPENSSL),Y)
  SUBDIRS += openssl
endif

default: all

.PHONY: all clean distclean tags distdir install check dep

all: $(SUBDIRS:%=%/all)

# Extra dependencies to make parallel make work in spite of all the submakes
# (See top level make file for details)
abyss/all curl_transport/all: $(BLDDIR)/version.h
abyss++/all: abyss/all
abyss/all expat/all libutil++/all: libutil/all

clean: $(SUBDIRS:%=%/clean) clean-common

distclean: $(SUBDIRS:%=%/distclean) distclean-common

tags: $(SUBDIRS:%=%/tags) TAGS

DISTFILES = 

distdir: distdir-common

install: $(SUBDIRS:%=%/install)

uninstall: $(SUBDIRS:%=%/uninstall)

check:

dep: $(SUBDIRS:%=%/dep)

include $(SRCDIR)/common.mk

=== src/Makefile ===
ifeq ($(SRCDIR),)
  updir = $(shell echo $(dir $(1)) | sed 's/.$$//')
  SRCDIR := $(call updir,$(CURDIR))
  BLDDIR := $(SRCDIR)
endif
SUBDIR := src

include $(BLDDIR)/config.mk

default: all

SUBDIRS =

ifeq ($(ENABLE_CPLUSPLUS),yes)
  SUBDIRS += cpp
endif

TARGET_LIBRARY_NAMES := libxmlrpc libxmlrpc_server

# We cannot build libxmlrpc_server_abyss if we can't also build Abyss,
# because we need libxmlrpc_abyss in order to build the proper runtime
# dependencies into libxmlrpc_server_abyss.

ifeq ($(ENABLE_ABYSS_SERVER),yes)
  TARGET_LIBRARY_NAMES += libxmlrpc_server_abyss
endif

ifeq ($(MUST_BUILD_CLIENT),yes)
  TARGET_LIBRARY_NAMES += libxmlrpc_client
endif

ifeq ($(ENABLE_CGI_SERVER),yes)
  TARGET_LIBRARY_NAMES += libxmlrpc_server_cgi
endif

STATIC_LIBRARIES_TO_INSTALL = $(TARGET_STATIC_LIBRARIES)

SHARED_LIBS_TO_BUILD := $(TARGET_LIBRARY_NAMES)
SHARED_LIBS_TO_INSTALL := $(TARGET_LIBRARY_NAMES)

# TRANSPORT_MODS is the list of modules that have to go into the client
# library to provide the client XML transport functions.

# TRANSPORT_LIBDEP is linker -l options to declare what libraries contain
# things to which the transport objects refer.  (like LIBxxx_LIBDEP --
# see below)

TRANSPORT_MODS =
TRANSPORT_LIBDEP =
TRANSPORT_INCLUDES =
ifeq ($(MUST_BUILD_WININET_CLIENT),yes)
  TRANSPORT_MODS += $(BLDDIR)/lib/wininet_transport/xmlrpc_wininet_transport
  TRANSPORT_LIBDEP += $(shell wininet-config --libs)
  TRANSPORT_INCLUDES += -Isrcdir/lib/wininet_transport
endif
ifeq ($(MUST_BUILD_CURL_CLIENT),yes)
  TRANSPORT_MODS += $(BLDDIR)/lib/curl_transport/xmlrpc_curl_transport
  TRANSPORT_MODS += $(BLDDIR)/lib/curl_transport/curltransaction
  TRANSPORT_MODS += $(BLDDIR)/lib/curl_transport/curlmulti
  TRANSPORT_LIBDEP += $(shell $(CURL_CONFIG) --libs)
  TRANSPORT_INCLUDES += -Isrcdir/lib/curl_transport
endif
ifeq ($(MUST_BUILD_LIBWWW_CLIENT),yes)
  TRANSPORT_MODS += $(BLDDIR)/lib/libwww_transport/xmlrpc_libwww_transport
  TRANSPORT_LIBDEP += $(shell libwww-config --libs)
  TRANSPORT_INCLUDES += -Isrcdir/lib/libwww_transport
endif

ifeq ($(ENABLE_LIBXML2_BACKEND),yes)
  XMLRPC_XML_PARSER = xmlrpc_libxml2
  XML_PARSER_LIBDEP = $(shell xml2-config --libs)
  XML_PARSER_LIBDEP_DEP =
  XML_PKGCONFIG_REQ = libxml-2.0
else
  XMLRPC_XML_PARSER = xmlrpc_expat
  XML_PARSER_LIBDEP = \
    -Lblddir/lib/expat/xmlparse -lxmlrpc_xmlparse \
    -Lblddir/lib/expat/xmltok -lxmlrpc_xmltok
  XML_PARSER_LIBDEP_DEP = $(LIBXMLRPC_XMLPARSE) $(LIBXMLRPC_XMLTOK)
  XML_PKGCONFIG_REQ = xmlrpc_expat
endif

# LIBxxx_OBJS is the list of object files that make up library libxxx.

LIBXMLRPC_MODS = \
	base_global \
        double \
	json \
	parse_datetime \
	parse_value \
        resource \
	trace \
	version \
	xmlrpc_data \
	xmlrpc_datetime \
	xmlrpc_string \
	xmlrpc_array \
	xmlrpc_struct \
	xmlrpc_build \
	xmlrpc_decompose \
	$(XMLRPC_XML_PARSER) \
	xmlrpc_parse \
	xmlrpc_serialize \
	xmlrpc_authcookie \

LIBXMLRPC_CLIENT_MODS = xmlrpc_client xmlrpc_client_global xmlrpc_server_info

LIBXMLRPC_SERVER_MODS = registry method system_method

LIBXMLRPC_SERVER_ABYSS_MODS = xmlrpc_server_abyss abyss_handler

LIBXMLRPC_SERVER_CGI_MODS = xmlrpc_server_cgi

TARGET_MODS = \
  $(LIBXMLRPC_MODS) \
  $(LIBXMLRPC_SERVER_MODS) \
  $(LIBXMLRPC_SERVER_ABYSS_MODS) \
  $(LIBXMLRPC_SERVER_CGI_MODS) \
  $(LIBXMLRPC_CLIENT_MODS) \

PKGCONFIG_FILES_TO_INSTALL := \
  xmlrpc.pc \
  xmlrpc_client.pc \
  xmlrpc_server.pc \
  xmlrpc_server_abyss.pc \
  xmlrpc_server_cgi.pc \

OMIT_XMLRPC_LIB_RULE=Y
MAJ=3
  # Major number of shared libraries in this directory

include $(SRCDIR)/common.mk

# This 'common.mk' dependency makes sure the symlinks get built before
# this make file is used for anything.

$(SRCDIR)/common.mk: srcdir blddir

# TARGET_STATIC_LIBRARIES, etc. are set by common.mk, based on
# TARGET_LIBRARY_NAMES.


all: \
  $(TARGET_STATIC_LIBRARIES) \
  $(TARGET_SHARED_LIBRARIES) \
  $(TARGET_SHARED_LE_LIBS) \
  $(PKGCONFIG_FILES_TO_INSTALL) \
  $(SUBDIRS:%=%/all) \

# Extra dependencies to make parallel make work in spite of all the submakes
# (See top level make file for details)

cpp/all: $(TARGET_SHARED_LE_LIBS)

ifeq ($MUST_BUILD_CLIENT),yes)
  cpp/all: $(BLDDIR)/transport_config.h
endif

#-----------------------------------------------------------------------------
#  RULES TO LINK LIBRARIES
#-----------------------------------------------------------------------------

# Rules for these are in common.mk, courtesy of TARGET_LIBRARY_NAMES:

# shlibfn generates e.g. libxmlrpc.so.3.1
# shliblefn generates e.g. libxmlrpc.so

LIBXMLRPC = $(call shlibfn, libxmlrpc)

$(LIBXMLRPC): $(LIBXMLRPC_MODS:%=%.osh) \
  $(LIBXMLRPC_UTIL) \
  $(XML_PARSER_LIBDEP_DEP)
$(LIBXMLRPC): LIBOBJECTS = $(LIBXMLRPC_MODS:%=%.osh)
$(LIBXMLRPC): LIBDEP = \
  $(LIBXMLRPC_UTIL_LIBDEP) \
  $(XML_PARSER_LIBDEP)

LIBXMLRPC_SERVER = $(call shlibfn, libxmlrpc_server)

$(LIBXMLRPC_SERVER): \
  $(LIBXMLRPC_SERVER_MODS:%=%.osh) \
  $(LIBXMLRPC_UTIL) \
  $(call shliblefn, libxmlrpc)
$(LIBXMLRPC_SERVER): LIBOBJECTS = $(LIBXMLRPC_SERVER_MODS:%=%.osh)
$(LIBXMLRPC_SERVER): LIBDEP = \
   -L. -lxmlrpc $(XML_PARSER_LIBDEP) $(LIBXMLRPC_UTIL_LIBDEP)

LIBXMLRPC_SERVER_ABYSS = $(call shlibfn, libxmlrpc_server_abyss)

$(LIBXMLRPC_SERVER_ABYSS): \
  $(LIBXMLRPC_SERVER_ABYSS_MODS:%=%.osh) \
  $(LIBXMLRPC_UTIL) \
  $(LIBXMLRPC_ABYSS) \
  $(call shliblefn, libxmlrpc_server) \
  $(call shliblefn, libxmlrpc)
$(LIBXMLRPC_SERVER_ABYSS): LIBOBJECTS = $(LIBXMLRPC_SERVER_ABYSS_MODS:%=%.osh)
$(LIBXMLRPC_SERVER_ABYSS): LIBDEP = \
  -L. -lxmlrpc_server \
  -L$(LIBXMLRPC_ABYSS_DIR) -lxmlrpc_abyss \
  -L. -lxmlrpc $(XML_PARSER_LIBDEP) $(LIBXMLRPC_UTIL_LIBDEP)
ifeq ($(MSVCRT),yes)
  $(LIBXMLRPC_SERVER_ABYSS):  LIBDEP += -lws2_32 -lwsock32
endif

LIBXMLRPC_SERVER_CGI = $(call shlibfn, libxmlrpc_server_cgi)

$(LIBXMLRPC_SERVER_CGI): \
  $(LIBXMLRPC_SERVER_CGI_MODS:%=%.osh) \
  $(LIBXMRPC_UTIL) \
  $(call shliblefn, libxmlrpc_server) \
  $(call shliblefn, libxmlrpc)
$(LIBXMLRPC_SERVER_CGI): LIBOBJECTS = $(LIBXMLRPC_SERVER_CGI_MODS:%=%.osh)
$(LIBXMLRPC_SERVER_CGI): LIBDEP = \
  -L. -lxmlrpc_server \
  -L. -lxmlrpc $(XML_PARSER_LIBDEP) $(LIBXMLRPC_UTIL_LIBDEP)

LIBXMLRPC_CLIENT = $(call shlibfn, libxmlrpc_client)

$(LIBXMLRPC_CLIENT): \
  $(LIBXMLRPC_CLIENT_MODS:%=%.osh) \
  $(TRANSPORT_MODS:%=%.osh) \
  $(LIBXMLRPC_UTIL) \
  $(call shliblefn, libxmlrpc)
$(LIBXMLRPC_CLIENT): LIBOBJECTS = \
  $(LIBXMLRPC_CLIENT_MODS:%=%.osh) \
  $(TRANSPORT_MODS:%=%.osh)

# We try to get Xmlrpc-c directories early in the link library search
# path to avert problems with other versions of Xmlrpc-c being in more
# general directories (such as /usr/local/lib) that are added to the
# search path by curl-config, etc.  That's why we separate the -L from
# the corresponding -l.
# 
# Note that in a properly configured system, curl-config, etc. do not
# generate -L options for general directories.

LIBXMLRPC_CLIENT_LIBDEP = \
  -Lblddir/src -Lblddir/lib/libutil \
  -lxmlrpc -lxmlrpc_util \
  $(XML_PARSER_LIBDEP) \
  $(TRANSPORT_LIBDEP) \

$(LIBXMLRPC_CLIENT): LIBDEP = \
  $(LIBXMLRPC_CLIENT_LIBDEP) \
  $(SOCKETLIBOPT) \
  $(THREAD_LIBS) \

libxmlrpc.a: $(LIBXMLRPC_MODS:%=%.o)
libxmlrpc.a: LIBOBJECTS = $(LIBXMLRPC_MODS:%=%.o)

libxmlrpc_server.a: $(LIBXMLRPC_SERVER_MODS:%=%.o)
libxmlrpc_server.a: LIBOBJECTS = $(LIBXMLRPC_SERVER_MODS:%=%.o)

libxmlrpc_server_abyss.a: $(LIBXMLRPC_SERVER_ABYSS_MODS:%=%.o)
libxmlrpc_server_abyss.a: LIBOBJECTS=$(LIBXMLRPC_SERVER_ABYSS_MODS:%=%.o)

libxmlrpc_server_cgi.a: $(LIBXMLRPC_SERVER_CGI_MODS:%=%.o)
libxmlrpc_server_cgi.a: LIBOBJECTS=$(LIBXMLRPC_SERVER_CGI_MODS:%=%.o)

libxmlrpc_client.a: $(LIBXMLRPC_CLIENT_MODS:%=%.o) $(TRANSPORT_MODS:%=%.o)
libxmlrpc_client.a: LIBOBJECTS = \
  $(LIBXMLRPC_CLIENT_MODS:%=%.o) \
  $(TRANSPORT_MODS:%=%.o)


#-----------------------------------------------------------------------------
#  RULES TO COMPILE OBJECT MODULES FOR LIBRARIES
#-----------------------------------------------------------------------------

# Rules for these are in common.mk, courtesy of TARGET_MODS:

BASIC_INCLUDES = \
  -Iblddir \
  -Iblddir/include \
  -Isrcdir/include \
  -Isrcdir/lib/util/include \

ifeq ($(ENABLE_LIBXML2_BACKEND),yes)
  LIBXML_INCLUDES = $(shell xml2-config --cflags)
else
  LIBXML_INCLUDES = -Isrcdir/lib/expat/xmlparse
endif

$(LIBXMLRPC_MODS:%=%.o) \
$(LIBXMLRPC_MODS:%=%.osh): \
  INCLUDES = $(BASIC_INCLUDES) $(LIBXML_INCLUDES)

$(LIBXMLRPC_CLIENT_MODS:%=%.o) \
$(LIBXMLRPC_CLIENT_MODS:%=%.osh): \
  INCLUDES = $(BASIC_INCLUDES) $(TRANSPORT_INCLUDES)

$(LIBXMLRPC_SERVER_MODS:%=%.o) \
$(LIBXMLRPC_SERVER_MODS:%=%.osh): \
  INCLUDES = $(BASIC_INCLUDES)

$(LIBXMLRPC_SERVER_ABYSS_MODS:%=%.o) \
$(LIBXMLRPC_SERVER_ABYSS_MODS:%=%.osh): \
  INCLUDES = $(BASIC_INCLUDES) -Isrcdir/lib/abyss/src

$(LIBXMLRPC_SERVER_CGI_MODS:%=%.o) \
$(LIBXMLRPC_SERVER_CGI_MODS:%=%.osh): \
  INCLUDES = $(BASIC_INCLUDES)

#-----------------------------------------------------------------------------
#  RULES TO MAKE CFLAGS/LDFLAGS FILES
#
#  These are for builds in other directories of things that use libraries in
#  this directory.  E.g. when you build libxmlrpc_client++, it depends upon
#  libxmlrpc_client from this directory.  So the link of libxmlrpc_client++
#  must specify a dependency upon libxmlrpc_client and any library upon which
#  libxmlrpc_client depends, so the link command for libxmlrpc_client++
#  should include $(shell cat libxmlrpc_client.ldflags).
#  
#  Note that some systems don't need this because there is information in
#  libxmlrpc_client that tells libxmlrpc_client's dependencies, so you need
#  only find libxmlrpc_client to generate libxmlrpc_client++.
#-----------------------------------------------------------------------------

libxmlrpc_client.cflags:
	echo "$(TRANSPORT_INCLUDES)" >$@

libxmlrpc_client.ldflags:
	echo "-Lblddir/src -lxmlrpc_client $(LIBXMLRPC_CLIENT_LIBDEP)" >$@


#-----------------------------------------------------------------------------
# RULES TO MAKE PKGCONFIG FILES
#
# (These are files used by the 'pkg-config' program to get information about
# using the libraries we build)
#-----------------------------------------------------------------------------

xmlrpc.pc:
	rm -f $@
	@echo "Echoes to '$@' suppressed here ..."
	@echo "Name:        xmlrpc"                                        >>$@
	@echo "Description: Xmlrpc-c basic XML-RPC library"                >>$@
	@echo "Version:     $(XMLRPC_VERSION_STRING)"                      >>$@
	@echo	                                                           >>$@
	@echo "Requires: xmlrpc_util $(XML_PKGCONFIG_REQ)"                 >>$@
	@echo "Libs:     -L$(LIBDESTDIR) -lxmlrpc"                         >>$@
	@echo "Cflags:   -I$(HEADERDESTDIR)"                               >>$@

xmlrpc_client.pc:
	rm -f $@
	@echo "Echoes to '$@' suppressed here ..."
	@echo "Name:        xmlrpc_client"                                 >>$@
	@echo "Description: Xmlrpc-c XML-RPC client library"               >>$@
	@echo "Version:     $(XMLRPC_VERSION_STRING)"                      >>$@
	@echo	                                                           >>$@
	@echo "Requires: xmlrpc xmlrpc_util"                               >>$@
	@echo "Libs:     -L$(LIBDESTDIR) -lxmlrpc_client"                  >>$@
	@echo "Cflags:   -I$(HEADERDESTDIR)"                               >>$@

xmlrpc_server.pc:
	rm -f $@
	@echo "Echoes to '$@' suppressed here ..."
	@echo "Name:        xmlrpc_server"                                 >>$@
	@echo "Description: Xmlrpc-c XML-RPC server library"               >>$@
	@echo "Version:     $(XMLRPC_VERSION_STRING)"                      >>$@
	@echo	                                                           >>$@
	@echo "Requires: xmlrpc xmlrpc_util"                               >>$@
	@echo "Libs:     -L$(LIBDESTDIR) -lxmlrpc_server"                  >>$@
	@echo "Cflags:   -I$(HEADERDESTDIR)"                               >>$@

xmlrpc_server_abyss.pc:
	rm -f $@
	@echo "Echoes to '$@' suppressed here ..."

=== tools/Makefile ===
ifeq ($(SRCDIR),)
  updir = $(shell echo $(dir $(1)) | sed 's/.$$//')
  SRCDIR := $(call updir,$(CURDIR))
  BLDDIR := $(SRCDIR)
endif
SUBDIR := tools

include $(BLDDIR)/config.mk

SUBDIRS = \
  binmode-rpc-kit \
  lib \
  turbocharger \
  xml \

ifeq ($(MUST_BUILD_CLIENT),yes)
  SUBDIRS += xmlrpc xmlrpc_transport

  ifeq ($(ENABLE_CPLUSPLUS),yes)
    SUBDIRS += xml-rpc-api2cpp xml-rpc-api2txt xmlrpc_cpp_proxy

    ifeq ($(BUILD_XMLRPC_PSTREAM),yes)
      SUBDIRS += xmlrpc_pstream
    endif
  endif
endif

ifeq ($(ENABLE_CPLUSPLUS),yes)
  SUBDIRS += xmlrpc_dumpserver
endif

.PHONY: all clean distclean install uninstall check dep

all: $(SUBDIRS:%=%/all)

clean: $(SUBDIRS:%=%/clean)

distclean: $(SUBDIRS:%=%/distclean)

install: $(SUBDIRS:%=%/install)

uninstall: $(SUBDIRS:%=%/uninstall)

check:

dep: $(SUBDIRS:%=%/dep)

include $(SRCDIR)/common.mk

=== examples/cpp/Makefile ===
# Since the programs in this directories are examples for the user, this
# make file should be as ordinary as possible.  It should not rely heavily
# on included make files or configuration parameters.  It should not use
# libtool.  Also, we don't try to build or rebuild the libraries on which
# these programs depend.


ifeq ($(SRCDIR),)
SRCDIR = $(CURDIR)/../..
BLDDIR = $(SRCDIR)
endif
SUBDIR=examples/cpp

include $(BLDDIR)/config.mk

default: all

CXXFLAGS_ALL = $(CFLAGS_PERSONAL) $(CXXFLAGS) $(CADD)
LDFLAGS_ALL = $(LDFLAGS_PERSONAL) $(LDFLAGS) $(LADD)

# If this were a real application, working from an installed copy of
# Xmlrpc-c, XMLRPC_C_CONFIG would just be 'xmlrpc-c-config'.  It would be
# found in the user's PATH.
XMLRPC_C_CONFIG = $(BLDDIR)/xmlrpc-c-config.test


SERVERPROGS_CGI = \
  xmlrpc_sample_add_server.cgi

SERVERPROGS_ABYSS = \
  xmlrpc_inetd_server \
  xmlrpc_loop_server \
  xmlrpc_sample_add_server \
  callinfo_abyss_server \

CLIENTPROGS = \
  xmlrpc_sample_add_client \
  sample_add_client_complex \
  asynch_client \

# Build up PROGS:
PROGS = 

ifeq ($(ENABLE_ABYSS_SERVER),yes)
  PROGS += $(SERVERPROGS_ABYSS)
endif

ifeq ($(MUST_BUILD_CLIENT),yes)
  PROGS += $(CLIENTPROGS)
endif

ifeq ($(ENABLE_CGI_SERVER),yes)
  PROGS += $(SERVERPROGS_CGI) 
endif

PROGS += pstream_inetd_server pstream_serial_server

ifeq ($(MUST_BUILD_CLIENT),yes)
  PROGS += pstream_client
endif

INCLUDES = -I. $(shell $(XMLRPC_C_CONFIG) c++2 client abyss-server --cflags)

LIBS_SERVER_ABYSS = \
  $(shell $(XMLRPC_C_CONFIG) c++2 abyss-server --libs)

LIBS_SERVER_CGI = \
  $(shell $(XMLRPC_C_CONFIG) c++2 cgi-server --libs)

LIBS_CLIENT = \
  $(shell $(XMLRPC_C_CONFIG) c++2 client --libs)

LIBS_BASE = \
  $(shell $(XMLRPC_C_CONFIG) c++2 --libs)

all: $(PROGS)

$(SERVERPROGS_CGI):%.cgi:%_cgi.o
	$(CXXLD) -o $@ $^ $(LIBS_SERVER_CGI) $(LDFLAGS_ALL)

$(SERVERPROGS_ABYSS):%:%.o
	$(CXXLD) -o $@ $^ $(LIBS_SERVER_ABYSS) $(LDFLAGS_ALL)

$(CLIENTPROGS):%:%.o
	$(CXXLD) -o $@ $^ $(LIBS_CLIENT) $(LDFLAGS_ALL)


LIBS_PSTREAM_CLIENT = \
  $(shell $(XMLRPC_C_CONFIG) c++2 client --libs)

pstream_client:%:%.o
	$(CXXLD) -o $@ $^ $(LIBS_PSTREAM_CLIENT) $(LDFLAGS_ALL)

LIBS_PSTREAM_SERVER = \
  $(shell $(XMLRPC_C_CONFIG) c++2 pstream-server --libs)

pstream_inetd_server pstream_serial_server:%:%.o
	$(CXXLD) -o $@ $^ $(LIBS_PSTREAM_SERVER) $(LDFLAGS_ALL)

OBJECTS = $(patsubst %,%.o,$(patsubst %.cgi,%_cgi,$(PROGS)))

$(OBJECTS):%.o:%.cpp
	$(CXX) -c $(INCLUDES) $(CXXFLAGS_ALL) $<

# See example/Makefile for an explanation of config.h

$(OBJECTS): config.h

config.h:
	$(LN_S) $(BLDDIR)/xmlrpc_config.h $@

.PHONY: clean
clean:
	rm -f $(PROGS) *.o config.h

.PHONY: distclean
distclean: clean

.PHONY: dep depend
dep depend:
# We don't do dependencies in this directory, because it's supposed to be
# an example of what a program outside this package would do, so we can't
# go weaving it into the rest of the package.  Ergo, a developer must
# carefully clean and remake examples as he updates other parts of the tree.

=== lib/abyss++/Makefile ===
ifeq ($(SRCDIR),)
  updir = $(shell echo $(dir $(1)) | sed 's/.$$//')
  LIBDIR := $(call updir,$(CURDIR))
  SRCDIR := $(call updir,$(LIBDIR))
  BLDDIR := $(SRCDIR)
endif
SUBDIR := lib/abyss++

include $(BLDDIR)/config.mk

default: all

TARGET_LIB_NAMES_PP = \
  libxmlrpc_abyss++ \

STATIC_LIBRARIES_TO_INSTALL = $(TARGET_STATIC_LIBRARIES)

SHARED_LIBS_TO_BUILD = $(TARGET_LIB_NAMES_PP)
SHARED_LIBS_TO_INSTALL = $(TARGET_LIB_NAMES_PP)

# INCLUDES and DEP_SOURCES are used by dep-common target
INCLUDES = $(BASIC_INCLUDES)
DEP_SOURCES = *.cpp

LIBXMLRPC_ABYSSPP_MODS = AbyssServer AbyssChanSwitch AbyssEnvironment

ifeq ($(findstring mingw,$(HOST_OS)),mingw)
  LIBXMLRPC_ABYSSPP_MODS += AbyssChanSwitchWin
else
  LIBXMLRPC_ABYSSPP_MODS += AbyssChanSwitchUnix
  ifeq ($(MUST_BUILD_OPENSSL),yes)
    LIBXMLRPC_ABYSSPP_MODS += AbyssChanSwitchOpenSsl
  endif
endif

TARGET_MODS_PP = \
  $(LIBXMLRPC_ABYSSPP_MODS) \

PKGCONFIG_FILES_TO_INSTALL := xmlrpc_abyss++.pc

OMIT_ABYSSPP_LIB_RULE = Y
MAJ = 9
  # Major number of shared libraries in this directory

include $(SRCDIR)/common.mk


# This 'common.mk' dependency makes sure the symlinks get built before
# this make file is used for anything.

$(SRCDIR)/common.mk: srcdir blddir

BASIC_INCLUDES = \
  -Iblddir/include \
  -Isrcdir/include \
  -Iblddir \
  -Isrcdir/lib/util/include


# TARGET_STATIC_LIBARIES, etc. are set by common.mk, based on
# TARGET_LIB_NAMES_PP.

all: \
  $(TARGET_STATIC_LIBRARIES) \
  $(TARGET_SHARED_LIBS_PP) \
  $(TARGET_SHARED_LE_LIBS) \
  $(PKGCONFIG_FILES_TO_INSTALL) \


#-----------------------------------------------------------------------------
#  RULES TO LINK LIBRARIES
#-----------------------------------------------------------------------------

# The actual rules for this are in common.mk, courtesy of TARGET_LIB_NAMES_PP

# shlibfn generates e.g. libxmlrpc.so.3.1
# shliblefn generates e.g. libxmlrpc.so

# Sometimes -lpthread is necessary when link-editing a shared library that
# uses pthread services, and sometimes it is not.  We've seen links on
# Windows and AIX fail without it.  It seems to be a good idea in all cases,
# as it declares an actual dependency of the shared library.

LIBXMLRPC_ABYSSPP_SH = $(call shlibfn, libxmlrpc_abyss++)

$(LIBXMLRPC_ABYSSPP_SH): $(LIBXMLRPC_ABYSSPP_MODS:%=%.osh) \
  $(LIBXMLRPC_ABYSS) \
  $(LIBXMLRPC_UTILPP) \
  $(LIBXMLRPC_UTIL) \

$(LIBXMLRPC_ABYSSPP_SH): LIBOBJECTS = $(LIBXMLRPC_ABYSSPP_MODS:%=%.osh)
$(LIBXMLRPC_ABYSSPP_SH): LIBDEP = \
   -L. -Lblddir/src \
   -L$(LIBXMLRPC_ABYSS_DIR) -lxmlrpc_abyss \
   -L$(LIBXMLRPC_UTILPP_DIR) -lxmlrpc_util++ \
   -L$(LIBXMLRPC_UTIL_DIR) -lxmlrpc_util \
   $(SOCKETLIBOPT) \
   $(THREADLIBS) \

libxmlrpc_abyss++.a: $(LIBXMLRPC_ABYSSPP_MODS:%=%.o)
libxmlrpc_abyss++.a: LIBOBJECTS=$(LIBXMLRPC_ABYSSPP_MODS:%=%.o)

#-----------------------------------------------------------------------------
#  RULE TO COMPILE OBJECT MODULES FOR LIBRARY
#-----------------------------------------------------------------------------

# The actual rule for this is in common.mk, courtesy of TARGET_MODS_PP

$(LIBXMLRPC_ABYSSPP_MODS:%=%.o) \
$(LIBXMLRPC_ABYSSPP_MODS:%=%.osh): \
  INCLUDES = $(BASIC_INCLUDES)

#-----------------------------------------------------------------------------
# RULES TO MAKE PKGCONFIG FILES
#
# (These are files used by the 'pkg-config' program to get information about
# using the libraries we build)
#-----------------------------------------------------------------------------

xmlrpc_abyss++.pc:
	rm -f $@
	@echo "Echoes to '$@' suppressed here ..."
	@echo "Name:        xmlrpc_abyss++"                                >>$@
	@echo "Description: Xmlrpc-c Abyss HTTP C++ library"               >>$@
	@echo "Version:     $(XMLRPC_VERSION_STRING)"                      >>$@
	@echo	                                                           >>$@
	@echo "Requires: xmlrpc_abyss xmlrpc_util++"                       >>$@
	@echo "Libs:     -L$(LIBDESTDIR) -lxmlrpc_abyss++"                 >>$@
	@echo "Cflags:   -I$(HEADERDESTDIR)"                               >>$@

#-----------------------------------------------------------------------------
#  MISCELLANEOUS RULES
#-----------------------------------------------------------------------------

.PHONY: install
install: install-common

.PHONY: uninstall
uninstall: uninstall-common

.PHONY: clean clean-local distclean distclean-local
clean: clean-common clean-local
clean-local:

distclean: clean distclean-local distclean-common

distclean-local:

.PHONY: dep
dep: dep-common $(BLDDIR)/transport_config.h
dep-common: $(BLDDIR)/src/libxmlrpc_client.cflags

include depend.mk

=== lib/abyss/Makefile ===
ifeq ($(SRCDIR),)
  updir = $(shell echo $(dir $(1)) | sed 's/.$$//')
  LIBDIR := $(call updir,$(CURDIR))
  SRCDIR := $(call updir,$(LIBDIR))
  BLDDIR := $(SRCDIR)
endif
SUBDIR := lib/abyss

include $(BLDDIR)/config.mk

SUBDIRS = src

default: all

.PHONY: all
all: $(SUBDIRS:%=%/all)

.PHONY: clean
clean: $(SUBDIRS:%=%/clean) clean-common

.PHONY: distclean
distclean: $(SUBDIRS:%=%/distclean) distclean-common

.PHONY: tags
tags: $(SUBDIRS:%=%/tags) TAGS

DISTFILES = 

.PHONY: distdir
distdir: distdir-common

.PHONY: install
install: $(SUBDIRS:%=%/install)

.PHONY: uninstall
uninstall: $(SUBDIRS:%=%/uninstall)

.PHONY: dep
dep: $(SUBDIRS:%=%/dep)

include $(SRCDIR)/common.mk

=== lib/curl_transport/Makefile ===
ifeq ($(SRCDIR),)
  updir = $(shell echo $(dir $(1)) | sed 's/.$$//')
  LIBDIR := $(call updir,$(CURDIR))
  SRCDIR := $(call updir,$(LIBDIR))
  BLDDIR := $(SRCDIR)
endif
SUBDIR := lib/curl_transport

include $(BLDDIR)/config.mk

default: all

MODS := xmlrpc_curl_transport curltransaction curlmulti

.PHONY: all
all: $(MODS:%=%.o) $(MODS:%=%.osh)

# Rules for the above dependencies are in common.mk,
# courtesy of TARGET_MODS.

TARGET_MODS = $(MODS)

OMIT_CURL_TRANSPORT_RULE=Y

include $(SRCDIR)/common.mk

# This 'common.mk' dependency makes sure the symlinks get built before
# this make file is used for anything.

$(SRCDIR)/common.mk: srcdir blddir

CURL_VERSION := $(shell $(CURL_CONFIG) --vernum)

# Some time at or before Curl 7.12, <curl/types.h> became an empty file
# (no-op).  Some time after Curl 7.18, <curl/types.h> ceased to exist.
# curl-config --vernum yields a string of 6 digits; the first two are the
# major version in hexadecimal; the second two are the minor version number
# and so on.  So "071000" means 7.16.0.

NEED_CURL_TYPES_H := $(shell if test $(CURL_VERSION) '<' 071000; then echo Y; fi)

ifeq ($(NEED_CURL_TYPES_H),Y)
  CFLAGS_LOCAL += -DNEED_CURL_TYPES_H
endif

# 074100 means 7.65.0
HAVE_CURL_MULTI_POLL := $(shell if test $(CURL_VERSION) '>' 074100; then echo Y; fi)

ifeq ($(HAVE_CURL_MULTI_POLL),Y)
  CFLAGS_LOCAL += -DHAVE_CURL_MULTI_POLL
endif


CURL_INCLUDES := $(shell $(CURL_CONFIG) --cflags)
# We expect that curl-config --cflags just gives us -I options, because
# we need just the -I options for 'make dep'.  Plus, it's scary to think
# of what any other compiler flag would do to our compile.

INCLUDES = \
  -I$(BLDDIR) \
  -I$(BLDDIR)/include \
  -Isrcdir/include \
  -Isrcdir/lib/util/include \
  $(CURL_INCLUDES)

.PHONY: clean
clean: clean-common

.PHONY: distclean
distclean: clean distclean-common

.PHONY: tags
tags: TAGS

.PHONY: distdir
distdir:

.PHONY: install
install:

.PHONY: uninstall
uninstall:

.PHONY: dep
dep: dep-common

include depend.mk

# Need this dependency for those who don't use depend.mk.
# Without it, version.h doesn't get created.
xmlrpc_curl_transport.o xmlrpc_curl_transport.osh: version.h

=== lib/expat/Makefile ===
ifeq ($(SRCDIR),)
  updir = $(shell echo $(dir $(1)) | sed 's/.$$//')
  LIBDIR := $(call updir,$(CURDIR))
  SRCDIR := $(call updir,$(LIBDIR))
  BLDDIR := $(SRCDIR)
endif
SUBDIR := lib/expat

include $(BLDDIR)/config.mk

default: all

SUBDIRS = gennmtab xmlparse xmltok

PKGCONFIG_FILES_TO_INSTALL := xmlrpc_expat.pc

include $(SRCDIR)/common.mk

.PHONY: all
all: $(SUBDIRS:%=%/all) $(PKGCONFIG_FILES_TO_INSTALL)

# Extra dependencies to make parallel make work in spite of all the submakes
# (See top level make file for details)
xmlparse/all: gennmtab/all xmltok/all
xmltok/all: gennmtab/all

#-----------------------------------------------------------------------------
# RULES TO MAKE PKGCONFIG FILES
#
# (These are files used by the 'pkg-config' program to get information about
# using the libraries we build)
#-----------------------------------------------------------------------------

xmlrpc_expat.pc:
	rm -f $@
	@echo "Echoes to '$@' suppressed here ..."
	@echo "Name:        xmlrpc_expat"                                  >>$@
	@echo "Description: Xmlrpc-c XML parsing library"                  >>$@
	@echo "Version:     $(XMLRPC_VERSION_STRING)"                      >>$@
	@echo	                                                           >>$@
	@echo "Requires: xmlrpc_util"                                      >>$@
	@echo "Libs:     -L$(LIBDESTDIR) -lxmlrpc_xmlparse -lxmlrpc_xmltok" >>$@
	@echo "Cflags:   -I$(HEADERDESTDIR)"                               >>$@

.PHONY: clean
clean: $(SUBDIRS:%=%/clean) clean-common

.PHONY: distclean
distclean: $(SUBDIRS:%=%/distclean) clean-common distclean-common

.PHONY: tags
tags: $(SUBDIRS:%=%/tags) TAGS

DISTFILES = 

.PHONY: distdir
distdir: distdir-common

.PHONY: install
install: install-common $(SUBDIRS:%=%/install)

.PHONY: uninstall
uninstall: uninstall-common $(SUBDIRS:%=%/uninstall)

.PHONY: check
check:

.PHONY: dep
dep: $(SUBDIRS:%=%/dep)

=== lib/libutil++/Makefile ===
ifeq ($(SRCDIR),)
  updir = $(shell echo $(dir $(1)) | sed 's/.$$//')
  srcDIR := $(call updir,$(CURDIR))
  SRCDIR := $(call updir,$(srcDIR))
  BLDDIR := $(SRCDIR)
endif
SUBDIR := lib/libutil++

include $(BLDDIR)/config.mk

default: all

TARGET_LIB_NAMES_PP = libxmlrpc_util++

STATIC_LIBRARIES_TO_INSTALL = $(TARGET_STATIC_LIBRARIES)

SHARED_LIBS_TO_BUILD = $(TARGET_LIB_NAMES_PP)
SHARED_LIBS_TO_INSTALL = $(TARGET_LIB_NAMES_PP)

# INCLUDES and DEP_SOURCES are used by dep-common target
INCLUDES = $(BASIC_INCLUDES)
DEP_SOURCES = *.cpp

LIBXMLRPC_UTILPP_MODS = Lock base64 env_wrap girerr girmem

TARGET_MODS_PP = \
  $(LIBXMLRPC_UTILPP_MODS) \

PKGCONFIG_FILES_TO_INSTALL := xmlrpc_util++.pc

OMIT_LIBXMLRPC_UTILPP_RULE = Y
MAJ = 9
  # Major number of shared libraries in this directory

include $(SRCDIR)/common.mk


# This 'common.mk' dependency makes sure the symlinks get built before
# this make file is used for anything.

$(SRCDIR)/common.mk: srcdir blddir

BASIC_INCLUDES = \
  -Iblddir/include \
  -Isrcdir/include \
  -Iblddir \
  -Isrcdir/lib/util/include


# TARGET_STATIC_LIBARIES, etc. are set by common.mk, based on
# TARGET_LIB_NAMES_PP.

all: \
  $(TARGET_STATIC_LIBRARIES) \
  $(TARGET_SHARED_LIBS_PP) \
  $(TARGET_SHARED_LE_LIBS) \
  $(PKGCONFIG_FILES_TO_INSTALL) \


#-----------------------------------------------------------------------------
#  RULES TO LINK LIBRARIES
#-----------------------------------------------------------------------------

# Rules for these are in common.mk, courtesy of TARGET_LIB_NAMES_PP:

# shlibfn generates e.g. libxmlrpc.so.3.1
# shliblefn generates e.g. libxmlrpc.so

# Sometimes -lpthread is necessary when link-editing a shared library that
# uses pthread services, and sometimes it is not.  We've seen links on
# Windows and AIX fail without it.  It seems to be a good idea in all cases,
# as it declares an actual dependency of the shared library.

LIBXMLRPC_UTILPP_SH = $(call shlibfn, libxmlrpc_util++)

$(LIBXMLRPC_UTILPP_SH): $(LIBXMLRPC_UTILPP_MODS:%=%.osh) \
  $(LIBXMLRPC_UTIL) \

$(LIBXMLRPC_UTILPP_SH): LIBOBJECTS = $(LIBXMLRPC_UTILPP_MODS:%=%.osh)
$(LIBXMLRPC_UTILPP_SH): LIBDEP = \
   -L$(LIBXMLRPC_UTIL_DIR) -lxmlrpc_util \
   $(THREAD_LIBS) \

libxmlrpc_util++.a: $(LIBXMLRPC_UTILPP_MODS:%=%.o)
libxmlrpc_util++.a: LIBOBJECTS = $(LIBXMLRPC_UTILPP_MODS:%=%.o)

#-----------------------------------------------------------------------------
#  RULES TO COMPILE OBJECT MODULES FOR LIBRARIES
#-----------------------------------------------------------------------------

# Rules for these are in common.mk, courtesy of TARGET_MODS_PP.


#-----------------------------------------------------------------------------
# RULES TO MAKE PKGCONFIG FILES
#
# (These are files used by the 'pkg-config' program to get information about
# using the libraries we build)
#-----------------------------------------------------------------------------

xmlrpc_util++.pc:
	rm -f $@
	@echo "Echoes to '$@' suppressed here ..."
	@echo "Name:        xmlrpc_util++"                                 >>$@
	@echo "Description: Xmlrpc-c C++ utility functions library"        >>$@
	@echo "Version:     $(XMLRPC_VERSION_STRING)"                      >>$@
	@echo	                                                           >>$@
	@echo "Requires: xmlrpc_util"                                      >>$@
	@echo "Libs:     -L$(LIBDESTDIR) -lxmlrpc_util++"                  >>$@
	@echo "Cflags:   -I$(HEADERDESTDIR)"                               >>$@

#-----------------------------------------------------------------------------
#  MISCELLANEOUS RULES
#-----------------------------------------------------------------------------

.PHONY: install
install: install-common

.PHONY: uninstall
uninstall: uninstall-common

.PHONY: clean clean-local distclean distclean-local
clean: clean-common clean-local
clean-local:

distclean: clean distclean-local distclean-common

distclean-local:

.PHONY: dep
dep: dep-common

include depend.mk

=== lib/libwww_transport/Makefile ===
ifeq ($(SRCDIR),)
  updir = $(shell echo $(dir $(1)) | sed 's/.$$//')
  LIBDIR := $(call updir,$(CURDIR))
  SRCDIR := $(call updir,$(LIBDIR))
  BLDDIR := $(SRCDIR)
endif
SUBDIR := lib/libwww_transport

include $(BLDDIR)/config.mk

default: all

.PHONY: all
all: xmlrpc_libwww_transport.o xmlrpc_libwww_transport.osh

# Rules for the above dependencies are in common.mk,
# courtesy of TARGET_MODS.

TARGET_MODS = xmlrpc_libwww_transport

OMIT_LIBWWW_TRANSPORT_RULE=Y

include $(SRCDIR)/common.mk

# This 'common.mk' dependency makes sure the symlinks get built before
# this make file is used for anything.

$(SRCDIR)/common.mk: srcdir blddir

LIBWWW_INCLUDES := $(shell libwww-config --cflags)

INCLUDES = \
  -I$(BLDDIR) \
  -I$(BLDDIR)/include \
  -Isrcdir/include \
  -Isrcdir/lib/util/include \
  $(LIBWWW_INCLUDES)

.PHONY: clean
clean: clean-common

.PHONY: distclean
distclean: clean distclean-common

.PHONY: tags
tags: TAGS

.PHONY: distdir
distdir:

.PHONY: install
install:

.PHONY: uninstall
uninstall: uninstall-common

.PHONY: dep
dep: dep-common

include depend.mk

# Need this dependency for those who don't use depend.mk.
# Without it, version.h doesn't get created.
xmlrpc_libwww_transport.o xmlrpc_libwww_transport.osh: version.h

=== lib/util/Makefile ===
###############################################################################
# This directory builds object modules that provide utility functions that
# programs can use.  Not libraries, though -- just programs.  The reason
# we don't want any library to use object modules in here is that they'll
# probably pollute the name space when users link those libraries to their
# programs.  In fact, if more than one Xmlrpc-c library included one of these
# modules, the libraries would conflict with each other.
#
# So a utility function that is to be used by libraries (and, optionally,
# programs) should go in libxmlrpc_util.  libxmlrpc_util is a prerequisite
# for many Xmlrpc-c libraries, gets included in a program link only once,
# and uses external symbol names that have the "xmlrpc_" prefix to avoid
# collision with users' code.
#
# If we knew a portable way to link multiple object modules into one and
# restrict the symbols exported by the whole, we could avoid this mess and
# just link utility object modules into each Xmlrpc-c library.
##############################################################################

ifeq ($(SRCDIR),)
  updir = $(shell echo $(dir $(1)) | sed 's/.$$//')
  LIBDIR := $(call updir,$(CURDIR))
  SRCDIR := $(call updir,$(LIBDIR))
  BLDDIR := $(SRCDIR)
endif
SUBDIR := lib/util

default: all

include $(BLDDIR)/config.mk

OMIT_UTILS_RULE = Y

include $(SRCDIR)/common.mk

# This 'common.mk' dependency makes sure the symlinks get built before
# this make file is used for anything.

$(SRCDIR)/common.mk: srcdir blddir

LIBOBJS = \
  casprintf.o \
  cmdline_parser.o \
  getoptx.o \
  string_parser.o \
  stripcaseeq.o \

# If the overall build is not building C++ libraries, then it isn't building
# any tools that use them, and it's a good assumption that it isn't building
# any program written in C++.  Since the main reason for not building C++
# libraries is that your build system can't compile C++, it makes sense not to
# attempt to compile any C++ code if we're not building C++ libraries.  Hence,
# we don't build any C++ code here if ENABLE_CPLUSPLUS is "no".

ifeq ($(ENABLE_CPLUSPLUS),yes)
  LIBOBJS += cmdline_parser_cpp.o
endif

.PHONY: all
all: $(LIBOBJS)

INCLUDES = -Isrcdir/$(SUBDIR)/include -I$(BLDDIR)

%.o:%.c
	$(CC) -c $(CFLAGS_ALL) $<

%.o:%.cpp
	$(CXX) -c $(CXXFLAGS_ALL) $<

include depend.mk

.PHONY: clean distclean
clean: clean-common

distclean: clean distclean-common

.PHONY: dep
dep: dep-common

.PHONY: install
install:

.PHONY: uninstall
uninstall:

=== debian/changelog ===
xmlrpc-c (1.59.03-10.1) unstable; urgency=medium

  * Non-maintainer upload.
  * fix gcc15 build (Closes: #1098155)

 -- Victor Seva <vseva@debian.org>  Thu, 11 Sep 2025 11:44:24 +0200

xmlrpc-c (1.59.03-10) unstable; urgency=medium

  * Depends on external libexpat1-dev (Closes: #1104753)
  * Reinstate hardening patch, fix blhc job on Salsa

 -- Alexandre Detiste <tchet@debian.org>  Sat, 17 May 2025 14:32:20 +0200

xmlrpc-c (1.59.03-9) unstable; urgency=high

  * Expand libexpat1 patch to also update xmlrpc-c-config &
    the pkg-config snippet. (Closes: #1104366, #1104362)

 -- Alexandre Detiste <tchet@debian.org>  Fri, 02 May 2025 16:37:03 +0200

xmlrpc-c (1.59.03-8) unstable; urgency=medium

  * Use system libexpat1 instead of old vendored libexpat (Closes: #1102554)
  * Drop kfreebsd patch

 -- Alexandre Detiste <tchet@debian.org>  Sat, 19 Apr 2025 12:48:36 +0200

xmlrpc-c (1.59.03-7) unstable; urgency=medium

  * Rewrite d/copyright in machine-parsable format

 -- Alexandre Detiste <tchet@debian.org>  Sun, 16 Mar 2025 23:03:22 +0100

xmlrpc-c (1.59.03-6) unstable; urgency=medium

  [ Yegor Yefremov ]
  * Backport pkg-config patch from 1.6x.x branch (Closes: #1086167)

 -- Alexandre Detiste <tchet@debian.org>  Fri, 08 Nov 2024 13:15:48 +0100

xmlrpc-c (1.59.03-5) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: Update variable name for build architecture compiler.
    (Closes: #1084809)

 -- Alexandre Detiste <tchet@debian.org>  Wed, 16 Oct 2024 18:19:19 +0200

xmlrpc-c (1.59.03-4) unstable; urgency=medium

  * Add a the libxmlrpc-core-c3-dev -> libxmlrpc-util-dev
    dependency (Closes: #1072163)

 -- Alexandre Detiste <tchet@debian.org>  Fri, 31 May 2024 12:37:13 +0200

xmlrpc-c (1.59.03-3) unstable; urgency=medium

  * add 'Replaces:' (Closes: #1071735)

 -- Alexandre Detiste <tchet@debian.org>  Sat, 25 May 2024 17:47:54 +0200

xmlrpc-c (1.59.03-2) unstable; urgency=medium

  * Split-out xmlrpc-utils4 (Closes: #1071465)
  * Apply Multi-Arch hint
  * Close old Ubuntu bugs: (LP: #464509, LP: #1865344)

 -- Alexandre Detiste <tchet@debian.org>  Wed, 22 May 2024 10:14:45 +0200

xmlrpc-c (1.59.03-1) unstable; urgency=medium

  * Adopt package (Closes: #773435)
  * New upstream version 1.59.03 (Closes: #524550)
  * Switch to debhelper compat 13
  * Refresh patches
  * Bump soname for C++ lib, no reverse dep in Debian
  * Merge remaining time64 changes for C lib from the NMU
  * Provide .pc files for pkg-config (Closes: #614423)
  * LTO does work now (Closes: #1015709)
  * Pull in curl development package when installing
    xmlrpc devevelopement (Closes: #928702)

  [ Jörg Frings-Fürst ]
  * Work for new release
  * Imported Upstream version 1.33.15+svn20141226~2672
  * Imported Upstream version 1.33.17

 -- Alexandre Detiste <tchet@debian.org>  Fri, 10 May 2024 18:40:43 +0200

xmlrpc-c (1.33.14-12) unstable; urgency=medium

  * QA upload.
  * Fix extraneous X-Time64-Compat declarations.

 -- Steve Langasek <vorlon@debian.org>  Sun, 03 Mar 2024 21:26:20 +0000

xmlrpc-c (1.33.14-11.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063279

 -- Steve Langasek <vorlon@debian.org>  Thu, 29 Feb 2024 07:39:42 +0000

xmlrpc-c (1.33.14-11) unstable; urgency=medium

  * QA upload.

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable)

 -- Jelmer Vernooĳ <jelmer@debian.org>  Thu, 13 Oct 2022 13:27:40 +0100

xmlrpc-c (1.33.14-10) unstable; urgency=medium

  * QA upload.

  [ Debian Janitor ]
  * Remove constraints unnecessary since stretch:
    + Build-Depends: Drop versioned constraint on debhelper.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sun, 22 Aug 2021 03:19:47 +0100

=== debian/control ===
Source: xmlrpc-c
Priority: optional
Section: libs
Maintainer: Alexandre Detiste <tchet@debian.org>
# co-maintain & team-maintain is welcome
Build-Depends:
 debhelper-compat (= 13),
 dpkg-dev (>= 1.22.5),
 libcurl4-openssl-dev | libcurl3-openssl-dev,
 libexpat1-dev,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: http://xmlrpc-c.sourceforge.net
Vcs-Git: https://salsa.debian.org/debian/xmlrpc-c.git
Vcs-Browser: https://salsa.debian.org/debian/xmlrpc-c
X-Style: black

Package: libxmlrpc-c++9-dev
Section: libdevel
Architecture: any
Depends:
 libc6-dev,
 libxmlrpc-c++9 (= ${binary:Version}),
 libxmlrpc-core-c3-dev (= ${binary:Version}),
 ${misc:Depends},
Suggests:
 xmlrpc-api-utils,
Conflicts:
 libxmlrpc-c++8-dev,
Description: Lightweight RPC library based on XML and HTTP [C++ development libraries]
 XML-RPC is a quick-and-easy way to make procedure calls over the Internet.
 It converts the procedure call into an XML document, sends it to a remote
 server using HTTP, and gets back the response as XML.
 .
 This library provides a modular implementation of XML-RPC for C++.
 .
 Install this package if you wish to develop your own programs using this
 library.

Package: libxmlrpc-c++9
Architecture: any
Depends:
 libxmlrpc-core-c3t64 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 libxmlrpc-c++8,
Replaces:
 libxmlrpc-c++8,
Description: Lightweight RPC library based on XML and HTTP [C++ runtime libraries]
 XML-RPC is a quick-and-easy way to make procedure calls over the Internet.
 It converts the procedure call into an XML document, sends it to a remote
 server using HTTP, and gets back the response as XML.
 .
 This library provides a modular implementation of XML-RPC for C++.

Package: libxmlrpc-core-c3-dev
Section: libdevel
Architecture: any
Depends:
 libc6-dev,
 libcurl4-openssl-dev | libcurl4-gnutls-dev,
 libexpat1-dev,
 libxmlrpc-core-c3t64 (= ${binary:Version}),
 libxmlrpc-util-dev,
 ${misc:Depends},
Suggests:
 xmlrpc-api-utils,
Description: Lightweight RPC library based on XML and HTTP [C development libraries]
 XML-RPC is a quick-and-easy way to make procedure calls over the Internet.
 It converts the procedure call into an XML document, sends it to a remote
 server using HTTP, and gets back the response as XML.
 .
 This library provides a modular implementation of XML-RPC for C.
 .
 Install this package if you wish to develop your own programs using this
 library.

Package: libxmlrpc-core-c3t64
Provides:
 ${t64:Provides},
Replaces:
 libxmlrpc-core-c3,
Breaks:
 libxmlrpc-core-c3 (<< ${source:Version}),
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Lightweight RPC library based on XML and HTTP [C runtime libraries]
 XML-RPC is a quick-and-easy way to make procedure calls over the Internet.
 It converts the procedure call into an XML document, sends it to a remote
 server using HTTP, and gets back the response as XML.
 .
 This library provides a modular implementation of XML-RPC for C.

Package: libxmlrpc-util4
Architecture: any
Multi-Arch: same
Breaks:
 libxmlrpc-core-c3 (<< 1.59.03-2),
 libxmlrpc-core-c3t64 (<< 1.59.03-2),
Replaces:
 libxmlrpc-core-c3 (<< 1.59.03-2),
 libxmlrpc-core-c3t64 (<< 1.59.03-2),
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Lightweight RPC library based on XML and HTTP [extra C runtime libraries]
 XML-RPC is a quick-and-easy way to make procedure calls over the Internet.
 It converts the procedure call into an XML document, sends it to a remote
 server using HTTP, and gets back the response as XML.
 .
 This library provides extra utility functions.

Package: libxmlrpc-util-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Breaks:
 libxmlrpc-core-c3-dev (<< 1.59.03-2),
Replaces:
 libxmlrpc-core-c3-dev (<< 1.59.03-2),
Depends:
 libxmlrpc-util4 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Lightweight RPC library based on XML and HTTP [extra development libraries]
 XML-RPC is a quick-and-easy way to make procedure calls over the Internet.
 It converts the procedure call into an XML document, sends it to a remote
 server using HTTP, and gets back the response as XML.
 .
 This library provides extra utility functions.
 .
 Install this package if you wish to develop your own programs using this
 library.

Package: xmlrpc-api-utils
Conflicts:
 xml-rpc-api2cpp,
 xml-rpc-api2txt,
Provides:
 xml-rpc-api2cpp,
 xml-rpc-api2txt,
Replaces:
 xml-rpc-api2cpp,
 xml-rpc-api2txt,
Architecture: any
Section: devel
Depends:
 libc6-dev,
 libfrontier-rpc-perl,
 libxmlrpc-c++9 (= ${binary:Version}),
 libxmlrpc-core-c3t64 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Generate C++ wrapper classes for XML-RPC servers
 XML-RPC is a quick-and-easy way to make procedure calls over the Internet.
 It converts the procedure call into an XML document, sends it to a remote
 server using HTTP, and gets back the response as XML.
 .
 This package contains two programs:
  * xml-rpc-api2cpp, a utility for generating C++ wrapper classes based
    on an XML-RPC API, obtained by interrogating an XML-RPC server.
  * xml-rpc-api2txt, a utility for printing out an XML-RPC API as a
    text file.  The API is obtained by interrogating an XML-RPC server.

=== debian/rules ===
#!/usr/bin/make -f

#export DEB_BUILD_MAINT_OPTIONS = optimize=+lto

include /usr/share/dpkg/buildtools.mk

%:
	dh $@ --without=autoreconf

override_dh_auto_configure:
	# Strip the following unused file from the tree to prevent it from being
	# used as the license is incompatible with lib/util/getoptx.*
	rm -fv tools/turbocharger/mod_gzip.c
	dh_auto_configure -- \
		--disable-libwww-client \
		--disable-wininet-client

override_dh_auto_build:
	dh_auto_build -- 'CC_FOR_BUILD=$(CC_FOR_BUILD)'
	dh_auto_build --sourcedirectory=tools

override_dh_auto_clean:
	# Add here commands to clean up after the build process.
	# xxx upstream build process still breaks on distclean...
	[ ! -f Makefile ] || [ ! -f config.status ] || dh_auto_clean || true

override_dh_compress:
	dh_compress -Xusr/share/doc/libxmlrpc-core-c3-dev/examples/
